'Egy BASIC mintaprogram a PICDEMO panelre.
'Az A0 analog bemenet beolvassa, egy 8 bites adatknt eltrolja, az eredmnyt kiirja az LCD-re
'A relt - ezt most egy LED szimullja - pedig az eredmnytl fggen kapcsolgatja.

' Konfigurljuk a PORTA-t. Teht hogy melyik kivezetseket akarjuk digitlis, vagy 
' analg portnak hasznlni, mi legyen a mrs referencia feszltsge. 
' Ezeket az ANSELA-B-C-D, az ADCON0 s ADCON1 regiszterbe tlttt adat fogja meghatrozni. 
' Szval, ha azt akarjuk, hogy a PORTA.0-1-3 mint analog,
' a PORTA.2-4-5 mint digitlis port legyen hasznlva, a
' a mrs referencia feszltsge pedig a tpfesz legyen, akkor:

' Akr 14 lb hasznlhat analg bemenetnek, de most csak a porta 0-3 legyen analg, a tbbi digitlis.
   ANSELA = %00001111    ' porta 0-3 analg, a 4-7 digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis
   
	ADCON0 = %00000001	' Az ADC0, ADC ON regiszter 
'Jobbra igaztva az eredmny, Fosc/4 az A/D rajel, az ADref- a VSS, ADref+ a VCC :
	ADCON1 = %11000000	' Az ADref- a VSS, ADref+ a VCC  

'Kzljk a programmal, hol tallja az LCD-t, es hogyan akarjuk vezrelni:
   	DEFINE LCD_DREG 	PORTD ' Az LCD adatvezetket a D portrol vezreljk
	DEFINE LCD_DBIT 	4	' Az els adatvezetk az RD.4
	DEFINE LCD_RSREG 	PORTC ' Az LCD Register Select kivezetse a C portra csatlakozik,
	DEFINE LCD_RSBIT 	0	' mgpedig az RC.0 labra. (Tehat az LCD RS - az RC.0 porton van.)
	DEFINE LCD_EREG 	PORTC ' Az enable vezerl bit is a C porton,
	DEFINE LCD_EBIT 	1	' az RC1 portra van kiosztva. (LCD EN - RC.1 port.)
	DEFINE LCD_BITS 	4	' a 4 bites uzemmodot vlasztjuk,
	DEFINE LCD_LINES 	2	' es 2 soros az LCD

	TRISA = %00001111	' A PORTA0-3 bemenet, a PORTA 4-7 kimenet legyen
	TRISB = %00000000	' A PORTB0-7 output

	RELE var PORTB.0			' A rel/LED a PORTB 0-n vezrlve,
    PIROSLED var PORTB.1        ' Egy jelz LED

	' Helyet foglalunk a vltozoknak a mikrokontroller RAM-jaban
	ANAL0 var word		' Az ANAL0-ba kerl majd az RA0-on porton,
	
	Define  ADC_BITS     10   ' Set number of bits in result
	'Define  ADC_CLOCK    4    ' Set clock source Fosc/4
    'Define  ADC_SAMPLEUS 50   ' Set sampling time in uS


main:	ADCIN 0, ANAL0			' Beolvassuk az AN0 bemenetet az ANAL0 vltozoba
	
	LCDOUT $fe,1,"Analog= ",DEC4 ANAL0	' LCD trles, es irs az els sorba
		
	IF ANAL0 >= 100 Then
		HIGH RELE ' Ha ANAL0 100-nl nagyobb, a rel bekapcsol 
	ENDIF

	IF ANAL0 <= 80 Then
		LOW RELE 	' Ha 80 al megy. a rel kikapcsol
	ENDIF
	
	TOGGLE PIROSLED	' a ktszn LED piros felnek ki/bekapcsolgatsa (Mukodesjelzes)
			
	PAUSE 500		' 500 msec, azaz fl masodperc pause
	GOTO main		' Ugras a ciklus elejere, kezdodik minden ujra... 
	END				' Itt a progi vege. Ha tekergetjuk a potit, ltjuk az
					' eredmenyt az LCD-n, s kapcsol a rel
